

function startCommand()
	game:add("console", {

	})
end

function getFloor(depth)
	if not depth then
		depth = state "depth"
	end

	return "default"
end

function prompt(button, action)

end

function loadXP(file)
	return game.xp:read(file)
end

function explode(x, y, radius)
	game.state.explode = {}

	fov(x, y, radius, function(x, y)
		game.state.explode[f('%i,%i', x, y)] = {
			x = x,
			y = y
		}
	end)

	game:add("sfx/explosion", {
		x = x,
		y = y,
		radius = radius,
		spaces = deepcopy(game.state.explode),
		grid = {
			x = x,
			y = y
		}
	})

	game.state.explode = nil

end

function fov(x, y, radius, success, options)
	game.fov(x,y,radius, function(x, y, sx, sy, radius, options)
		if game.terminal:contains(x, y) then
			return game.terminal:getTileData(x, y).opaque
		else
			return false
		end
	end, success, nil, nil, options)
end

get_fov = fov

function terminal(text, choices, x, y)
	game:findQueue{
		type = "async",
		context = "scene",
		id = "terminal",
		text = text,
		choices = choices,
		x = x,
		y = y,
		start = function(self)
			self.window = game:add("ui/terminal_window", {
				x = x or math.floor((game.terminal.width / 2) - 25),
				y = y or math.floor(game.terminal.height / 2) - 3,
				behavior = {
					text = text,
					choices = choices
				}
			})
		end,
		update = function(self, dt, speed)
			self.finished = not game:get(self.window.name)
		end
	}
end

function log(message)
	table.insert(game.terminal.log, 1, message)
	game.terminal.lastLog = 0

	if #game.terminal.log > 20 then
		while #game.terminal.log > 20 do
			table.remove(game.terminal.log, #game.terminal.log)
		end
	end
end

function tile(id)
	return game.definitions.Tile[id]
end

function getEntitiesAt(x, y)
	local entities = {}

	for index, entity in pairs(game:getEntities(function (entity) return entity.grid end)) do
		if entity.grid.x == x and entity.grid.y == y then
			table.insert(entities, entity)
		end
	end

	return entities
end

function addTurns(amount)
	game:getSystem("behavior").turns = game:getSystem("behavior").turns + amount
end
