return function()
    return {
        opacity = 0,
        update = function(self, dt, speed)
            local doneMove = false
            local target = {0, 0}

            self.opacity = self.opacity + (dt * speed)
            self.parent.glyph.background = {
                255, 255, 0, math.lerp(0, 255, self.opacity % 1)
            }

            if game.controls:pressed "up" then
                target = game.definitions.directions.up
                self.dir = "up"
                doneMove = true
            elseif game.controls:pressed "down" then
                target = game.definitions.directions.down
                self.dir = "down"
                doneMove = true
            elseif game.controls:pressed "left" then
                target = game.definitions.directions.left
                self.dir = "left"
                doneMove = true
            elseif game.controls:pressed "right" then
                target = game.definitions.directions.right
                self.dir = "right"
                doneMove = true
            end

            if doneMove then
                move_to(target.x, target.y, nil, 0.01)
            end

            if game.controls:pressed "a" then
                if game.promise:exists("cursor") then
                    game.promise:resolve("cursor")

                    if game:get("player") then
                        local player = game:get("player")

                        player.behavior.state:idle(player)
                    end

                    game:remove(self.parent)
                end
            end
        end,
        draw = function(self)
            game.terminal:setLayer "ui"
            game.terminal:print(game.terminal:getTileData(self.parent.grid.x, self.parent.grid.y).text, nil, nil, nil, {0,0,0}, true)

            for index, entity in pairs(getEntitiesAt(self.parent.grid.x, self.parent.grid.y)) do
                if entity.stats then
                    game.terminal:print(entity.stats.name, 2, game.terminal.height - index, {255, 255, 0}, {0,0,0}, true)
                end
            end
        end
    }
end
