return function()
    return {
        age = 0,
        dir = 1,
        awake = function(self)
            game.locked = true

            for index, space in pairs(self.parent.spaces) do
                local entities = getEntitiesAt(space.x, space.y)

                if #entities > 0 then
                    for index, entity in pairs(entities) do
                        entity.behavior:onExplode(self.parent.grid.x, self.parent.grid.y, self.parent.radius)
                    end
                end
            end
        end,
        update = function(self, dt, speed)
            self.age = self.age + ((dt * speed * 5) * self.dir)

            if self.age > 1 then
                game.locked = false
                game:remove(self.parent)
            end
        end,
        draw = function(self)
            for index, space in pairs(self.parent.spaces) do
                local opac = math.lerp(200, 255, 1 - (math.dist(self.parent.grid.x, self.parent.grid.y, space.x, space.y) / self.parent.radius))
                game.terminal:print("*", space.x, space.y, {0, 0, 0, 0}, game.terminal:colerp({255, 0, 0, opac}, {255, 255, 0, opac}, self.age))
            end
        end
    }
end
