return function()
    return {
        awake = function(self)
            self.parent.stats.flavor = self.parent.stats.flavor_idle
            self.state = game:machine{
                initial = "soaking",
                events = {
                    {name = "free", from = "soaking", to = "idle"},
                    {name = "kill", from = {"idle", "attacking"}, to = "dead"},
                    {name = "attack", from = "idle", to = "attacking"}
                },
                callbacks = {
                    onfree = function(self, event, from, to, parent)
                        local lc = game.context
                        game.context = parent

                        if math.random(1, 2) == 1 then
                            log "The tank explodes, spilling its thick, brackish fluids all over the lab floors."
                            parent.behavior.state:kill(parent, true)
                            parent.stats.flavor = parent.stats.flavor_dead
                            explode(parent.grid.x, parent.grid.y, 4)
                            move_to(-2, 0, MoveType.Relative)
                        else
                            log "The specimen stumbles out of the tank, staggered."
                            parent.stats.flavor = parent.stats.flavor_alive
                            move_to(0, 2, MoveType.Relative)
                            parent.behavior.state:attack(parent, true)
                        end

                        game.context = lc
                    end,
                    onkill = function(self, event, from, to, parent, fate)
                        if fate then
                            log "The specimen falls to the floor... pathetic."
                        end
                    end
                }
            }
        end,
        update = function(self, dt, speed)
            if self.parent.stats.health <= 0 then
                self:kill()
            end
        end,
        turn = function(self)
            local turns = 1

            if self[self.state.current] then
                turns = self[self.state.current](self)
            end

            return turns
        end,
        on_hit = function(self, interactor)
            if interactor.class == "player" then
                if self.state.current == "dead" then
                    local move = {
                        x = 0,
                        y = 0
                    }

                    if interactor.grid.x > self.parent.grid.x then
                        move.x = -1
                    elseif interactor.grid.x < self.parent.grid.x then
                        move.x = 1
                    end

                    if interactor.grid.y > self.parent.grid.y then
                        move.y = -1
                    elseif interactor.grid.y < self.parent.grid.y then
                        move.y = 1
                    end
                    local lc = game.context
                    game.context = self.parent
                    move_to(move.x, move.y, MoveType.Relative)
                    game.context = lc
                else
                    log "You hit the specimen for 3 damage."
                    self.parent.stats.health = self.parent.stats.health - 3
                end
            end
        end,
        free = function(self)
            if math.random(1, 10) == 1 then
                log "The specimen loses its balance."
                self.trips = self.trips + 1

                if self.trips > 5 then
                    log "The specimen falls to the ground."
                    self.state:kill(self.parent, true)
                end
            end
        end,
        kill = function(self)
            log "You finish this specimen's struggle for it."
            game:remove(self.parent)
        end
    }
end
