return function()
    return {
        spaces = {},
        divisions = 1,
        awake = function(self)
            self.spaces = {
                {
                    age = 15,
                    x = self.parent.grid.x,
                    y = self.parent.grid.y
                }
            }
        end,
        turn = function(self)
            if #self.spaces == 0 then
                game:remove(self.parent)
            end

            local divided = false

            for position, space in pairs(self.spaces) do
                space.age = space.age - 1

                if not divided then
                    if math.random(1, 20) >= self.divisions then
                        self.divisions = self.divisions + 1
                        divided = true

                        for i, dir in pairs(game.definitions.directions) do
                            if game.terminal:contains(space.x + dir.x, space.y + dir.y) then
                                if not tileCollides(space.x + dir.x, space.y + dir.y) then
                                    self.spaces[f("%i,%i", space.x + dir.x, space.y + dir.y)] = {
                                        age = math.floor(space.age),
                                        x = space.x + dir.x,
                                        y = space.y + dir.y
                                    }
                                end
                            end
                        end
                    end
                end

                if space.age <= 0 then
                    self.spaces[position] = nil
                end
            end

            return 1
        end,
        draw = function(self)
            game.terminal:setLayer "entities"

            for index, space in pairs(self.spaces) do
                game.terminal:print(string.char(176), space.x, space.y, {255, 255, 255}, {125, 255, 125}, true)
            end
        end
    }
end
