--
--
--
--
--
return function()
    return {
        age = 0,
        speed = 30,
		lineHeight = 10,

        class = "selector",
		font = game.defaultFont,
        active = true,
        buttons = {},
        selected = 1,
		anchored = true,
        lastSelected = false,
        layer = "ui",

        update = function(self, dt, speed)
            self.age = self.age + (dt * speed)
            local spacer = " "

            self.lastSelected = self.selected

            if self.active then
                if game.controls:pressed 'up' then
                    self.age = 0
                    self.selected = self.selected - 1
                    if self.selected == 0 then
                        self.selected = #self.buttons
                    end

					if self.buttons[self.selected].onhover then
						if type(self.buttons[self.selected].onhover) == "string" then
							loadstring(self.buttons[self.selected].onhover)(self)
						else
							self.buttons[self.selected].onhover(self)
						end
					end
                end

                if game.controls:pressed 'down' then
                    self.age = 0
                    self.selected = self.selected + 1
                    if self.selected > #self.buttons then
                        self.selected = 1
                    end

					if self.buttons[self.selected].onhover then
						if type(self.buttons[self.selected].onhover) == "string" then
							loadstring(self.buttons[self.selected].onhover)(self)
						else
							self.buttons[self.selected].onhover(self)
						end
					end
                end

                if self.lastSelected ~= self.selected then
                    if self.buttons[self.selected].onselect then
                        self.buttons[self.selected].onselect(self)
                    end
                end

                self.selected = math.clamp(self.selected, 1, #self.buttons)

                if game.controls:pressed "a" then
                    if type(self.buttons[self.selected].onclick) == "string" then
                        loadstring(self.buttons[self.selected].onclick)(self)
                    else
                        self.buttons[self.selected].onclick(self)
                    end
                    self:choose()
                end
            end
        end,
        choose = function(self)
            self.active = false
            self.selector = 1
        end,
        draw = function(self)
            local lc = love.graphics.getCanvas()
            love.graphics.setCanvas(game.layers[self.layer])
			love.graphics.setFont(game.fonts[self.font])

            local color = (self.age % 1 < 0.5 and self.active) and "White" or "Black"

			local drawX = math.floor(self.anchored and 0 or game.camera.x) + self.x
			local drawY = math.floor(self.anchored and 0 or game.camera.y) + self.y

            game.windows.dialogue:draw(drawX, drawY, self.width, self.height)
            for index, button in ipairs(self.buttons) do
                if index == self.selected and self.active then
                    love.graphics.printf(formatText(string.format("^%s>^White %s", color, button.label)), drawX + 8, drawY + (self.lineHeight * index), self.width - 8, "left")
                else
                    love.graphics.printf(formatText(button.label), drawX + 8, drawY + (self.lineHeight * index), self.width - 8, "left")
                end
            end

            love.graphics.setCanvas(lc)
        end
    }
end
