--
--
--
--
--

game.terminal:setLayer "persistent_ui"
game.terminal:clear('persistent_ui', '$', nil, nil, nil, nil, {0, 0, 0}, {0, 0, 0})
game.terminal:writeCenter("Generating map layout...", 8)
code(function ()
    game.terminal:setLayer "map"
    game.terminal:clear()

    game.terminal:generateWorld(
        game.terminal.width,
        game.terminal.height,
        function(map, x, y, value)

        end,
        (state "depth" == 1)
    )
end)
wait(1)
code(function ()
    game.terminal:setLayer "persistent_ui"
    game.terminal:writeCenter("Processing and building rooms...", 10)
end)
code(function ()
    game.terminal:processWorld(require 'assets.scripts.process_world')
end)
wait(1)
code(function()
    local lc = game.terminal.currentLayer
    game.terminal:setLayer "persistent_ui"
    game.terminal:writeCenter("Populating world...", 12)

    game.terminal:populateWorld()

    game.terminal:setLayer(lc)
end)

local index = 1
game.state.notifs = {}
game.promise:promise("loading_message", {
    onResolve = function(self)

    end,
    message = "Getting loading messages...",
    onUpdate = function(self, dt, speed)
        game.terminal:setLayer "ui"
        game.terminal:writeCenter(self.message, 15, nil, nil)
    end
})

if state("depth") == 1 then
    local lines = {}

    for str in love.filesystem.lines("assets/text/loading.txt") do
        table.insert(lines, str)
    end

    for index, str in pairs(lines) do
        code(function(self)
            game.terminal:clear 'ui'
            game.promise:set("loading_message", "message", self.options.str)
        end, {str = str, i = index})

        wait(math.lerp(0.5, 0.1, index / #lines))
    end
else
    wait(0.1)
end

code(function(self)
    game.terminal:setLayer "persistent_ui"
    game.terminal:writeCenter "[Press Z to begin.]"
end)

buttonPress "a"

code(function()
    game.promise:resolve("loading_message")
    game.terminal:renderMap('map')
    game.terminal:getLayer("ui").persistent = false
end)
code(function ()
    game.terminal:setLayer "ui"
    game.terminal:clear("persistent_ui")
    game.terminal:clear()
end)
