-- This code is run at load time.

state("depth", 1)

game.definitions.Tile = json("assets/tiles.json")

game.terminal:clearAll()
game.terminal:blankWorld(
    game.terminal.width,
    game.terminal.height,
	1
)
game.terminal:getLayer('entities').persistent = false
game.terminal:getLayer("debug").persistent = false
game.terminal:getLayer("ui").persistent = false
game.terminal:clear('structures')
game.terminal:setLayer "map"
game.targetContext = "scene"

local xp = loadXP("assets/structures/waterfall.xp")

for index, layer in ipairs(xp.layers) do
	if index == 1 then
		for index, cell in pairs(layer.cells) do
			if not (cell.char == " " and cell.bg[1] == 255 and cell.bg[2] == 0 and cell.bg[3] == 255) then
				game.terminal:print(cell.char, cell.x + 5, cell.y + 3, cell.fg, cell.bg)
			end
		end
	elseif index == 2 then
		for index, cell in pairs(layer.cells) do
			if cell.char == string.char(4) then
				game.terminal:setTile(cell.x + 5, cell.y + 3, 11)
			elseif cell.char == string.char(3) then
				game.terminal:setTile(cell.x + 5, cell.y + 3, 12)
			elseif cell.char == string.char(2) then
				game.terminal:setTile(cell.x + 5, cell.y + 3, 13)
			elseif cell.char == string.char(6) then
				game.terminal:setTile(cell.x + 5, cell.y + 3, 13)
			end
		end
	end
end

game:add("player", {
	grid = {
		x = 14,
		y = 18
	}
})
