--
--
-- Custom code to run after a room is loaded.
--
--

game.tempFlags = {}


if game.mapData.properties.script then
	script(game.mapData.properties.script)
else

	if game.activeScene == "main" then
		if scriptExists(f("rooms/%s", game.room)) then
			script(f("rooms/%s", game.room))
		end

		game.camera:setPriority(game:get "player")
	end
end

if game.mapData.properties.music then
	if love.filesystem.exists(game.mapData.properties.music) then
		if game.mapData.properties.music ~= game.playing then
			game.audio:stop("music")

			if game.mapData.properties.music ~= nil then
				game.audio:playLooping(game.mapData.properties.music, "music")
				game.playing = game.mapData.properties.music
			end
		end
	else
		printf("Map background music not found for area %s", area)
	end
end

game:getSystem("physics").gravity = game.gravity
