--
--
-- GLYPH layer
--
--

return function ()
    local glyph = game.system()

    function glyph:validate(entity)
		entity.glyph.parent = entity
		entity.glyph = table.merge(require("game.components.glyph")(), entity.glyph)

        return entity
    end

    function glyph:filter(entity)
        if entity.glyph then
            if entity.glyph.useGridComponent and not entity.grid then
                error "Entity's glyph cites grid component that doesn't exist."
            end

            return true
        end
    end

    function glyph:render(entity)
        local x, y = 0, 0

        if entity.glyph.useGridComponent then
            x = entity.grid.x
            y = entity.grid.y
        else
            x = math.floor(entity.x / game:getSystem("grid").width)
            y = math.floor(entity.y / game:getSystem("grid").height)
        end

        if game.terminal:contains(x, y) then
            if entity.glyph.layer then
                game.terminal:setLayer(entity.glyph.layer)
            end

            local char = "@"

            if type(entity.glyph.char) == "number" then
                char = string.char(entity.glyph.char)
            else
                char = entity.glyph.char
            end

            game.terminal:print(char, x, y, entity.glyph.color, entity.glyph.background, true)
        end
    end

    return glyph
end
