--
--
--
--
--

return function()
	local grid = game.system()

	grid.size = {
		width = 9,
		height = 16
	}

	function grid:validate(entity)
		self:align(entity, entity.grid.x and Grid.Prescriptive or Grid.Descriptive)
		if entity.grid.x ~= entity.grid.targetX then
			entity.grid.targetX = entity.grid.x
		end
		if entity.grid.y ~= entity.grid.targetY then
			entity.grid.targetY = entity.grid.y
		end

		return entity
	end

	function grid:syncToMap(map)
		self.syncedMap = map
	end

	function grid:filter(entity)
		return entity.grid
	end

	function grid:process(entity, dt, speed)
		if entity.grid.x ~= entity.grid.targetX then
			entity.grid.x = entity.grid.targetX
		end
		if entity.grid.y ~= entity.grid.targetY then
			entity.grid.y = entity.grid.targetY
		end

		entity = self:align(entity)
	end

	function grid:align(entity, type)
		if not type then
			type = entity.grid.alignType
		end

		if type == Grid.Prescriptive then
			entity.x = entity.grid.x * self.size.width + (0.5 * self.size.width)
			entity.y = entity.grid.y * self.size.height + (0.5 * self.size.height)
		elseif type == Grid.Descriptive then
			entity.grid.x = math.floor((entity.x - (0.5 * self.size.width)) / self.size.width)
			entity.grid.y = math.floor((entity.y - (0.5 * self.size.height)) / self.size.height)
		end

		return entity
	end

	return grid
end
